package xyz.zhouxy.plusone.exception.handler;

import javax.annotation.Nonnull;

import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.RestControllerAdvice;

import lombok.extern.slf4j.Slf4j;
import xyz.zhouxy.plusone.commons.exception.handler.BaseExceptionHandler;
import xyz.zhouxy.plusone.commons.util.RestfulResult;
import xyz.zhouxy.plusone.exception.SysException;

@RestControllerAdvice
@Slf4j
public class SysExceptionHandler extends BaseExceptionHandler {

    public SysExceptionHandler(@Nonnull ExceptionInfoHolder exceptionInfoHolder) {
        super(exceptionInfoHolder);
    }

    @ExceptionHandler({ SysException.class })
    public ResponseEntity<RestfulResult> handleException(@Nonnull Exception e) {
        log.error(e.getMessage(), e);
        HttpStatus httpStatus = getHttpStatus(e);
        return new ResponseEntity<>(RestfulResult.error(getErrorCode(e), "系统错误"), httpStatus);
    }
}
