package xyz.zhouxy.plusone.system.application.service.command.validator;

import java.util.List;

import org.springframework.stereotype.Component;

import xyz.zhouxy.plusone.commons.constant.PatternConsts;
import xyz.zhouxy.plusone.system.application.service.command.LoginByOtpCommand;
import xyz.zhouxy.plusone.validator.BaseValidator;
import xyz.zhouxy.plusone.validator.DtoValidator;

@Component
@DtoValidator(LoginByOtpCommand.class)
public class LoginByOtpCommandValidator extends BaseValidator<LoginByOtpCommand> {
    public LoginByOtpCommandValidator() {
        ruleForString(LoginByOtpCommand::getPrincipal)
                .notNull("输入邮箱地址或手机号")
                .notEmpty("输入邮箱地址或手机号")
                .matchesOr(List.of(PatternConsts.EMAIL, PatternConsts.MOBILE_PHONE), "输入用户名、邮箱地址或手机号");
        ruleForString(LoginByOtpCommand::getOtp)
                .notNull("验证码不能为空")
                .notEmpty("验证码不能为空")
                .matches(PatternConsts.CAPTCHA, "验证码格式不正确");
    }
}
